"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.preserveLeadingComments = void 0;
/**
 * Ensure that any leading comment is preserved at the top of the processed file before additional imports are
 * dynamically inserted during the build.
 *
 * @param path
 */
var preserveLeadingComments = function (path) {
    var _a, _b;
    var leadingComments = (_b = (_a = path.node.body) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.leadingComments;
    if (leadingComments) {
        path.addComments('leading', leadingComments);
        path.node.body[0].leadingComments = null;
    }
};
exports.preserveLeadingComments = preserveLeadingComments;
//# sourceMappingURL=preserve-leading-comments.js.map